#ifndef predictor_H_
#define preidctor_H_

#include <python3.6/Python.h>
#include <iostream>
#include <algorithm>
#include <string.h>

using namespace std;


class predictor
{
    public:
        predictor();
        ~predictor(); 
    
    public:
        long predict(string rule, string instance, char* macroFile, std::string keyList = "");
        void reset();
    private:
        PyObject *object, *pMethod_predict, *pMethod_load, *pMethod_reset, *pMethod_load_file, *pMethod_reset_all, *pMethod_set_keys;
        PyObject *pName, *pModule, *pName_networkx, *pModule_networkx;
        PyObject *dict, *python_class;
};

#endif //predictor_H_