import predictor, clingo

from predictor import Predictor
from clingo_ast_util import ASTVisitor

def main():
    global test_predictor
    test_predictor = Predictor()
    # test_predictor.load_program('encoding.lp')
    # test_predictor.load_program('instance.lp')
    # test_predictor.load_program('example4-simple.lp')
    # test_predictor.load_program('programs/test-1.lp')

    # test_predictor.load_program('programs/compatible/stable/encoding.asp')
    # test_predictor.load_program('programs/compatible/stable/instances/numeric/0001-stablemarriage-0-0.asp')

    # test_predictor.load_program('programs/compatible/blocked-n-queens/encoding.lp')
    # test_predictor.load_program('programs/compatible/solitaire/encoding.lp')
    # test_predictor.load_program('programs/compatible/ramsey/encoding.lp')

    # test_predictor.load_program('programs/incompatible/hanoi/encoding.asp')
    # test_predictor.load_program('programs/incompatible/hanoi/instances/0001-hanoi_tower-60-0.asp')

    test_predictor.load_program('programs/incompatible/graph-coloring/choice.lp')
    test_predictor.load_program('programs/incompatible/graph-coloring/instances/instance-1.lp')

    # test_predictor.load_program('programs/compatible/num-squares/finding-numbers/encoding-num.lp')
    # test_predictor.load_program('programs/compatible/num-squares/finding-numbers/pr-encoding.lp')
    # test_predictor.load_program('programs/compatible/num-squares/finding-numbers/instances/square_25_120_24_8') # Base: 40575007014, Predictor: 40574412810
    # test_predictor.load_program('programs/compatible/num-squares/finding-numbers/instances/square_8_51_7_8')

    # test_predictor.load_program('gr-estimates-1.lp')
    # test_predictor.load_program('gr-estimates-2.lp')

    # test_predictor.load_program('decomp_example.lp')
    rv = RuleVisitor()
    clingo.parse_program(
        # Stable Marriage
        # '''match(M,W) :- manAssignsScore(M,_,_), womanAssignsScore(W,_,_), not nonMatch(M,W).''',
        # '''match2(M,W) :- manAssignsScore(M,W,S), womanAssignsScore(W,M,S2), p(M).''',
        # '''p_fun_0(M,W) :- manAssignsScore(M,W,S).
        # match2(M,W) :- womanAssignsScore(W,M,S2); p(M); p_fun_0(M,W).''',
        # ''':- manAssignsScore(M,W,Smw), manAssignsScore(M,W,Smw).''',
        # Instance 1 real TOTAL PROGARM value: 8728443
        # '''#false :- match(M,W1); manAssignsScore(M,W,Smw); W1!=W; manAssignsScore(M,W1,Smw1); Smw>Smw1; match(M1,W); womanAssignsScore(W,M,Swm); womanAssignsScore(W,M1,Swm1); Swm>=Swm1.''',
        # Instance 1 real TOTAL PROGRAM value: 2711143
        # '''p_fun_11(V0,V1) :- match(V2,V0); womanAssignsScore(V0,V2,V1).
        #     false :- match(M,W1); manAssignsScore(M,W,Smw); W1!=W; manAssignsScore(M,W1,Smw1); Smw>Smw1; womanAssignsScore(W,M,Swm); Swm>=Swm1; p_fun_11(W,Swm1).''',

        # '''false :- match(M,W1); manAssignsScore(M,W,Smw); W1!=W; manAssignsScore(M,W1,Smw1); Smw>Smw1; match(M1,W); womanAssignsScore(W,M,Swm); womanAssignsScore(W,M1,Swm1); Swm>=Swm1.''',
        # '''p_fun_13(V0,V1,V2) :- match(V0,V2); womanAssignsScore(V2,V1,V3); womanAssignsScore(V2,V0,V4); V3>=V4.
        #    #false :- match(M,W1); manAssignsScore(M,W,Smw); W1!=W; manAssignsScore(M,W1,Smw1); Smw>Smw1; p_fun_13(M1,M,W).''',

        # '''p(X,Y,Z,S) :- s(S), a(X,Y,S-1), c(D,Y,Z), f(X,P,S-1), P >= D.''',
        # Num Squares
        # '''ok_num(N, Pos, X, Y, Dir) :- number(N, Pos, B_1), possible_place(N, X, Y, Dir), grid(X1, Y1, B_1), dir(Dir, X_d, Y_d), Y1=Y + Pos * Y_d, X1=X + Pos * X_d.''',
        # '''p_fun_12(V0,V1,V2,V3) :- number(V1,V2,V4); grid(V3,V0,V4).
        #    ok_num(N,Pos,X,Y,Dir) :- possible_place(N,X,Y,Dir); dir(Dir,X_d,Y_d); Y1=(Y+(Pos*Y_d)); X1=(X+(Pos*X_d)); p_fun_12(Y1,N,Pos,X1).''',

        # '''not_ok_num(N, X, Y, Dir) :- number(N, Pos, B), not ok_num(N, Pos, X, Y, Dir), possible_place(N, X, Y, Dir).''',
        # '''p_fun_10(V0,V1) :- number(V0,V1,V2).
        #    not_ok_num(N,X,Y,Dir) :- not ok_num(N,Pos,X,Y,Dir); possible_place(N,X,Y,Dir); p_fun_10(N,Pos).''',

        # '''possible_place(N, X, Y, Dir) :- not impossible_place(N, X, Y, Dir), num(N), square(X, Y), dir(Dir, X_d, Y_d).''',
        # '''p_fun_9(V0) :- dir(V0,V1,V2).
        #    possible_place(N,X,Y,Dir) :- not impossible_place(N,X,Y,Dir); num(N); square(X,Y); p_fun_9(Dir).''',

        # '''impossible_place(N, X, Y, Dir) :- number(N, Pos, B_1), square(X, Y), dir(Dir, X_d, Y_d), not square(X1, Y1), X1=X + Pos * X_d, Y1=Y + Pos * Y_d.''',
        # '''p_fun_3(V0,V1) :- number(V0,V1,V2).
        #    impossible_place(N,X,Y,Dir) :- square(X,Y); dir(Dir,X_d,Y_d); not square(X1,Y1); X1=(X+(Pos*X_d)); Y1=(Y+(Pos*Y_d)); p_fun_3(N,Pos).''',

        # Graph Coloring
        # '''{ chosenColour(N,red0); chosenColour(N,green0); chosenColour(N,blue0); chosenColour(N,red0); chosenColour(N,cyan0) } :- node(N).''',
        # '''{ chosenColour(N,C) : colour(C) } :- node(N).''',
        '''1 { chosenColour(N,C) : colour(C) } 1 :- node(N).''',

        # '''d(X,Y) :- a(X), b(Y).''',
        lambda stm: rv.visit(stm))
    prediction = test_predictor.predict_all_rules(rv.rules)
    # print('Sum of predictions: %s' % sum(predictions))
    # prediction = test_predictor.predict_loaded_program()
    # prediction = test_predictor.predict_rule(rv.rules[0])
    print('Prediction: %s' % prediction)
    

class RuleVisitor(ASTVisitor):

    def __init__(self):
        self.rules = []
    
    def visit_Rule(self, rule):
        print('Visiting: %s' % rule)
        self.rules.append(rule)
        # test_predictor.predict_rule(rule)

if __name__ == '__main__':
    main()
